﻿Imports Infragistics.Win.UltraWinDock

Public Class Form1

#Region "Code to re-sort the flyout tabs"

  Private Sub UltraButton1_Click(sender As System.Object, e As System.EventArgs) Handles UltraButton1.Click

    Me.SuspendLayout()
    UltraDockManager1.SuspendLayout()
    UltraDockManager1.AnimationEnabled = False
    Try
      'Loop over all dock locations of interest, and sort the tabs that are kept in that dock location.
      For Each tmpLocation As DockedLocation In {DockedLocation.DockedLeft, DockedLocation.DockedTop, DockedLocation.DockedRight, DockedLocation.DockedBottom}
        'Note that we sort the tab, and make sure that the tabs that contain the controls that we want at the top of the order are skipped.
        Call SortDockArea(UltraDockManager1, tmpLocation, {Label1, Label2})
      Next
    Finally
      UltraDockManager1.FlyIn()
      UltraDockManager1.ResumeLayout()
      Me.ResumeLayout()
      UltraDockManager1.AnimationEnabled = True
    End Try

  End Sub

  Private Sub SortDockArea(forUltraDockManager As UltraDockManager, forDockedLocation As DockedLocation, noSortObjects() As Object)
    'Get the list of DockableControlPanes that ust be held at the top of the sort order based on the controls passed in.
    Dim noSortDockableControlPanes As Generic.List(Of DockableControlPane) = _
      (From tmpObject As Object In noSortObjects Select GetPanelForObject(forUltraDockManager, tmpObject)).ToList

    'Get a list of DockableControlPanes, in alpha-sort order, that are not members of the 'noSort' list that are docked in a location.
    Dim otherPanels As Generic.List(Of KeyValuePair(Of String, DockableControlPane)) = _
      (From otherPanel As DockableControlPane In forUltraDockManager.ControlPanes _
        Where (Not (otherPanel.Pinned OrElse noSortDockableControlPanes.Contains(otherPanel)) AndAlso (otherPanel.DockAreaPane.DockedLocation = forDockedLocation)) _
        Order By otherPanel.Text Ascending _
        Select New KeyValuePair(Of String, DockableControlPane)(otherPanel.Text.ToUpper, otherPanel) _
      ).ToList()

    'Now that we have our sorted list, we make sure that noSort panels are at the top in reverese order.
    noSortDockableControlPanes.Reverse()
    For Each tmpPane As DockableControlPane In noSortDockableControlPanes
      'If the panel we're adding exists, is not pinned, and is docked in the correct position, we add it.
      If ((tmpPane IsNot Nothing) AndAlso (tmpPane.DockAreaPane.DockedLocation = forDockedLocation)) Then
        otherPanels.Insert(0, New KeyValuePair(Of String, DockableControlPane)(tmpPane.Text.ToUpper, tmpPane))
      End If
    Next tmpPane

    'Pin each that's unpinned, and then unpin all those that were unpinned before.
    For Each tmpEntry As KeyValuePair(Of String, DockableControlPane) In otherPanels
      If (tmpEntry.Value IsNot Nothing) Then
        With tmpEntry.Value
          If (Not (.Pinned)) Then 'If a tab is not pinned,
            .Pinned = True 'pin it,
            .Pinned = False 'and un-pin it to set the order.
          End If
        End With
      End If
    Next tmpEntry

  End Sub
  Private Function GetPanelForObject(forUltraDockManager As UltraDockManager, forObject As Object) As DockableControlPane

    Try
      Dim tmpDockableControlPane As DockableControlPane = Nothing 'Setup a DockableControlPane that we will load.

      If (TypeOf forObject Is DockableControlPane) Then 'If the object is a DockableControlPane, we just get it
        tmpDockableControlPane = DirectCast(forObject, DockableControlPane)
      ElseIf (TypeOf forObject Is Control) Then 'Otherwise, if it's a control, we get the DockableControlPane that hosts it.
        tmpDockableControlPane = forUltraDockManager.PaneFromControl(DirectCast(forObject, Control))
      End If

      'Make sure that the DockableControlPane exists, is unpinned, and is held at the location of interest. (or no location of interest)
      If ((tmpDockableControlPane IsNot Nothing) AndAlso Not (tmpDockableControlPane.Pinned)) Then
        Return tmpDockableControlPane
      End If

    Catch ex As Exception
    End Try
    Return Nothing 'If we get here, we return Notrhing.

  End Function

#End Region 'Code to re-sort the flyout tabs

End Class
